// DesignView.cpp : implementation of the CDesignView class
//

#include "stdafx.h"
#include "Design.h"

#include "DesignDoc.h"
#include "DesignView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CReportX m_report;
/////////////////////////////////////////////////////////////////////////////
// CDesignView

IMPLEMENT_DYNCREATE(CDesignView, CView)

BEGIN_MESSAGE_MAP(CDesignView, CView)
	//{{AFX_MSG_MAP(CDesignView)
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_WM_SIZE()
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_PRINT_SETUP, OnFilePrintSetup)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, OnFilePrintPreview)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_MERGE, OnEditMerge)
	ON_COMMAND(ID_EDIT_SPLIT, OnEditSplit)
	ON_COMMAND(ID_FORMAT_INSERTCOL, OnFormatInsertcol)
	ON_COMMAND(ID_FORMAT_INSERTROW, OnFormatInsertrow)
	ON_COMMAND(ID_FORMAT_DELETECOL, OnFormatDeletecol)
	ON_COMMAND(ID_INSERT_DELETEROW, OnInsertDeleterow)
	ON_COMMAND(ID_FORMAT_APPENDCOL, OnFormatAppendcol)
	ON_COMMAND(ID_FORMAT_APPENDROW, OnFormatAppendrow)
	ON_COMMAND(ID_WINDOW_FROZEN, OnWindowFrozen)
	ON_COMMAND(ID_WINDOW_UNFROZEN, OnWindowUnfrozen)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

BEGIN_EVENTSINK_MAP(CDesignView, CView)
    //{{AFX_EVENTSINK_MAP(CDesignView)
	ON_EVENT(CDesignView, ID_REPORTX, 4 /* OnSelectChange */, OnOnSelectChangeReportx1, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	ON_EVENT(CDesignView, ID_REPORTX, 8 /* OnInputChange */, OnOnInputChangeReportx1, VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CDesignView::OnOnSelectChangeReportx1(long aCol1, long aRow1, long aCol2, long aRow2) 
{
	// TODO: Add your control notification handler code here
	
}

void CDesignView::OnOnInputChangeReportx1(long aCol, long aRow) 
{
	// TODO: Add your control notification handler code here
	
}

/////////////////////////////////////////////////////////////////////////////
// CDesignView construction/destruction

CDesignView::CDesignView()
{
	// TODO: add construction code here

}

CDesignView::~CDesignView()
{
}

BOOL CDesignView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDesignView drawing

void CDesignView::OnDraw(CDC* pDC)
{
	CDesignDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CDesignView printing

BOOL CDesignView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDesignView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDesignView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDesignView diagnostics

#ifdef _DEBUG
void CDesignView::AssertValid() const
{
	CView::AssertValid();
}

void CDesignView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDesignDoc* CDesignView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDesignDoc)));
	return (CDesignDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDesignView message handlers

int CDesignView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_report.Create( NULL, WS_CHILD|WS_VISIBLE, CRect(0,0,0,0), this, ID_REPORTX);
	
	return 0;
}

void CDesignView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
    m_report.MoveWindow ( 0, 0, cx, cy, true );	
	m_report.SetAxBorderStyle(0); 
}

void CDesignView::OnFileNew() 
{
	m_report.NewReport(30, 100);	
}


void CDesignView::OnFileOpen() 
{
	static char BASED_CODE szFilter[] = "ReportXļ|*.rpxe|ļ|*.*||";
	CFileDialog filedialog(true, NULL, NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, szFilter, NULL);
	if (filedialog.DoModal() == IDOK)
	m_report.OpenReport( filedialog.GetPathName() );
}

void CDesignView::OnFileSave() 
{
	static char BASED_CODE szFilter[] = "ReportXļ|*.rpxe||";
	CFileDialog filedialog(false, NULL, NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, szFilter, NULL);
	if (filedialog.DoModal() == IDOK)
    	m_report.SaveReport( filedialog.GetPathName() + ".rpxe" );
}

void CDesignView::OnFilePrintSetup() 
{
	m_report.PrintSetup();
}

void CDesignView::OnFilePrintPreview() 
{
	m_report.PrintPreview();
}

void CDesignView::OnFilePrint() 
{
	m_report.PrintSheet(true);
}

void CDesignView::OnEditCut() 
{
	long col1, row1, col2, row2;
	m_report.GetSelectCell( &col1, &row1, &col2, &row2 );
	m_report.CutCell( col1, row1, col2, row2 );
}

void CDesignView::OnEditCopy() 
{
	long col1, row1, col2, row2;
	m_report.GetSelectCell( &col1, &row1, &col2, &row2 );
	m_report.CopyCell( col1, row1, col2, row2 );
}

void CDesignView::OnEditPaste() 
{
	long col1, row1;
	m_report.GetInputCell( &col1, &row1 );
	m_report.Paste( col1, row1, true );
}

void CDesignView::OnEditMerge() 
{
	long col1, row1, col2, row2;
	m_report.GetSelectCell( &col1, &row1, &col2, &row2 );
    m_report.MergeCell( col1, row1, col2, row2 ); 
}

void CDesignView::OnEditSplit() 
{
	long col1, row1, col2, row2;
	m_report.GetSelectCell( &col1, &row1, &col2, &row2 );
    m_report.SplitCell( col1, row1, col2, row2 ); 
}

void CDesignView::OnFormatInsertcol() 
{
	long col1, row1;
	m_report.GetInputCell( &col1, &row1 );
	m_report.InsertCol( col1, 1 );
}

void CDesignView::OnFormatInsertrow() 
{
	long col1, row1;
	m_report.GetInputCell( &col1, &row1 );
	m_report.InsertRow( row1, 1 );
}

void CDesignView::OnFormatDeletecol() 
{
	long col1, row1, col2, row2;
	m_report.GetSelectCell( &col1, &row1, &col2, &row2 );
    m_report.DeleteCol( col1, col2 - col1 + 1 ); 
}

void CDesignView::OnInsertDeleterow() 
{
	long col1, row1, col2, row2;
	m_report.GetSelectCell( &col1, &row1, &col2, &row2 );
    m_report.DeleteRow( row1, row2 - row1 + 1 );
}

void CDesignView::OnFormatAppendcol() 
{
	m_report.AppendCol(1);
}

void CDesignView::OnFormatAppendrow() 
{
	m_report.AppendRow(1);
}

void CDesignView::OnWindowFrozen() 
{
	long col1, row1;
	m_report.GetInputCell( &col1, &row1 );
	m_report.SetFrozenCol(m_report.GetLeftCol(), col1 - 1);
	m_report.SetFrozenRow(m_report.GetTopRow(), row1 - 1);
}

void CDesignView::OnWindowUnfrozen() 
{
	m_report.SetFrozenCol(0, 0);
	m_report.SetFrozenRow(0, 0);
}
