unit Alias;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,

  Grid, OleCtrls, ReportProj1_TLB;

type
  TAliasFrm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Button2: TButton;
    Label6: TLabel;
    Edit6: TEdit;
    Button3: TButton;
    Button4: TButton;
    ListView1: TListView;
    ReportX1: TReportX;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ReportX1InputChange(Sender: TObject; aCol, aRow: Integer);
  private
    { Private declarations }
  public
    { Public declarations }

    GridFrm: TGridFrm
  end;
  
implementation

{$R *.dfm}

procedure TAliasFrm.FormShow(Sender: TObject);
var
  i : Integer;
  TempStrs : TStringList;
begin
  ReportX1.OpenString(GridFrm.ReportX1.SaveString(False), False);
  TempStrs := TStringList.Create;
  TempStrs.Text := ReportX1.GetAllChartName();
  for i := 0 to TempStrs.Count - 1 do
    ReportX1.DelObjectChart(TempStrs[i]);
  ReportX1.CellReadOnly := True;
  ReportX1.PoleReadOnly := True;
  if (GridFrm.Inputx = 0) or (GridFrm.Inputy = 0) then
  begin
    Edit1.Text := '';
    Edit2.Text := '';
    Edit3.Text := '';
    Edit4.Text := '';
    Edit5.Text := '';
    Edit6.Text := '';
  end
  else begin
    Edit1.Text := IntToStr(GridFrm.Inputx);
    Edit2.Text := IntToStr(GridFrm.Inputy);
    Edit3.Text := GridFrm.ReportX1.GetCellAlias(GridFrm.Inputx,
      GridFrm.Inputx);
    Edit4.Text := IntToStr(GridFrm.Inputx);
    Edit5.Text := IntToStr(GridFrm.Inputy);
    Edit6.Text := GridFrm.ReportX1.GetCellAlias(GridFrm.Inputx,
      GridFrm.Inputx);
  end;
end;

procedure TAliasFrm.Button1Click(Sender: TObject);
begin
  GridFrm.ReportX1.SetCellAlias(StrToInt(Edit1.Text), StrToInt(Edit2.Text),
    Edit3.Text);
end;

procedure TAliasFrm.Button2Click(Sender: TObject);
begin
  GridFrm.ReportX1.SetCellAlias(StrToInt(Edit4.Text), StrToInt(Edit5.Text), '');
end;

procedure TAliasFrm.Button3Click(Sender: TObject);
var
  TempInt1 : Integer;
  TempInt2 : Integer;
begin
  GridFrm.ReportX1.GetCellCoordinate(Edit6.Text, TempInt1, TempInt2);
  GridFrm.ReportX1.SetCellAlias(TempInt1, TempInt2, '');
end;

procedure TAliasFrm.Button4Click(Sender: TObject);
var
  i, j : Integer;
  TempStr : string;
  TempItem : TListItem;
begin
  ListView1.Items.Clear();
  for i := 1 to GridFrm.ReportX1.ColCount do
  begin
    for j := 1 to GridFrm.ReportX1.RowCount do
    begin
      TempStr := GridFrm.ReportX1.GetCellAlias(i, j);
      if TempStr <> '' then
      begin
        TempItem := ListView1.Items.Add();
        TempItem.Caption := IntToStr(i);
        TempItem.SubItems.Add(IntToStr(j));
        TempItem.SubItems.Add(TempStr);
      end;
    end;
  end; 
end;

procedure TAliasFrm.ReportX1InputChange(Sender: TObject; aCol,
  aRow: Integer);
begin
  Edit1.Text := IntToStr(aCol);
  Edit2.Text := IntToStr(aRow);
  Edit3.Text := ReportX1.GetCellAlias(aCol, aRow);
  Edit4.Text := IntToStr(aCol);
  Edit5.Text := IntToStr(aRow);
  Edit6.Text := ReportX1.GetCellAlias(aCol, aRow);
end;

end.
