unit Expre;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,

  Grid, StdCtrls, OleCtrls, ReportProj1_TLB;

type
  TExpreFrm = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    ReportX1: TReportX;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button11: TButton;
    Button12: TButton;
    ComboBox1: TComboBox;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ReportX1SelectChange(Sender: TObject; aCol1, aRow1, aCol2,
      aRow2: Integer);
    procedure ReportX1CellLDown(Sender: TObject; aCol, aRow: Integer);
    procedure ReportX1CellLUp(Sender: TObject; aCol, aRow: Integer);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }

    function IntToLetter(aInputInt: Integer): string; 
    procedure CMDialogKey(var Message : TCMDialogKey);
      message CM_DIALOGKEY;
  public
    { Public declarations }

    GridFrm : TGridFrm;
    ExpressMinx : Integer;
    ExpressMiny : Integer;
    ExpressMaxx : Integer;
    ExpressMaxy : Integer;
    ExpressStr : string;
    ExpressStart : string;
    ExpressEnd : string;
    ExpressCursor : Integer;
  end;

var
  ExpreFrm: TExpreFrm;

implementation

{$R *.dfm}  

function TExpreFrm.IntToLetter(aInputInt: Integer): string;
var
  TempInt : Integer;
  TempStr : string;
begin
  TempStr := '';
  TempInt := aInputInt - 1;
  while TempInt >= 0 do
  begin
    TempStr := Char((TempInt mod 26) + 65) + TempStr;
    TempInt := (TempInt div 26) - 1;
  end;
  Result := TempStr;
end;

procedure TExpreFrm.CMDialogKey(var Message: TCMDialogKey);
begin
  if (Message.CharCode < 37) or (Message.CharCode > 40) then
    Inherited;
end;

procedure TExpreFrm.Button1Click(Sender: TObject);
var
  i, j : Integer;
begin
  for i := ExpressMinx to ExpressMaxx do
    for j := ExpressMiny to ExpressMaxy do
      GridFrm.ReportX1.SetCellExpression(i, j, Memo1.Text);

  ModalResult := MrOk; 
end;

procedure TExpreFrm.FormShow(Sender: TObject);
var
  i, j : Integer;
  TempStrs : TStringList;
begin
  if ReportX1 <> nil then
  begin
    ReportX1.OpenString(GridFrm.ReportX1.SaveString(False), False);
    TempStrs := TStringList.Create;
    TempStrs.Text := ReportX1.GetAllChartName();
    for i := 0 to TempStrs.Count - 1 do
      ReportX1.DelObjectChart(TempStrs[i]);
    for i := ExpressMinx to ExpressMaxx do
      for j := ExpressMiny to ExpressMaxy do
        ReportX1.SetCellBackColor(i, j, clGray);
    ReportX1.CellReadOnly := True;
    ReportX1.PoleReadOnly := True;
  end;
end;

procedure TExpreFrm.Button2Click(Sender: TObject);
begin
  Close();
end;

procedure TExpreFrm.ReportX1SelectChange(Sender: TObject; aCol1, aRow1,
  aCol2, aRow2: Integer);
begin
  if (aCol1 = aCol2) and (aRow1 = aRow2) then
  begin
    ExpreFrm.Memo1.Text := ExpreFrm.ExpressStart + IntToLetter(aCol1) +
      IntToStr(aRow1) + ExpreFrm.ExpressEnd;
    ExpreFrm.Memo1.SelStart := ExpreFrm.ExpressCursor + Length(
      IntToLetter(aCol1) + IntToStr(aRow1));
  end
  else begin
    ExpreFrm.Memo1.Text := ExpreFrm.ExpressStart +
      Combobox1.Items[Combobox1.ItemIndex] + '(' +
      IntToLetter(aCol1) + IntToStr(aRow1) + ':' +
      IntToLetter(aCol2) + IntToStr(aRow2) + ')' +
      ExpreFrm.ExpressEnd;
    ExpreFrm.Memo1.SelStart := ExpreFrm.ExpressCursor + Length(
      Combobox1.Items[Combobox1.ItemIndex] + '(' +
      IntToLetter(aCol1) + IntToStr(aRow1) + ':' +
      IntToLetter(aCol2) + IntToStr(aRow2) + ')');
  end;
end;

procedure TExpreFrm.ReportX1CellLDown(Sender: TObject; aCol,
  aRow: Integer);
begin
  ExpressStart := Copy(Memo1.Text, 1, Memo1.SelStart);
  ExpressEnd := Copy(Memo1.Text, Memo1.SelStart + Memo1.SelLength + 1,
    Length(Memo1.Text) - (Memo1.SelStart + Memo1.SelLength));
  ExpressCursor := Memo1.SelStart;
end;

procedure TExpreFrm.ReportX1CellLUp(Sender: TObject; aCol, aRow: Integer);
begin
  ExpreFrm.ExpressStart := '';
  ExpreFrm.ExpressEnd := '';
  ExpreFrm.ExpressCursor := -1;
  Memo1.SetFocus();
end;

procedure TExpreFrm.Button3Click(Sender: TObject);
var
  TempInt : Integer;
begin
  TempInt := Memo1.SelStart;
  Memo1.Text := Copy(Memo1.Text, 1, Memo1.SelStart) +
    (Sender as TButton).Caption +
    Copy(Memo1.Text, Memo1.SelStart + Memo1.SelLength + 1,
    Length(Memo1.Text) - (Memo1.SelStart + Memo1.SelLength));
  Memo1.SetFocus();
  Memo1.SelStart := TempInt +
    Length((Sender as TButton).Caption);
end;

end.
