using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Designer
{
    public partial class Alias : Form
    {
        public Grid grid;

        public Alias()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            grid.reportX.SetCellAlias(int.Parse(textBox1.Text), int.Parse(textBox2.Text),
                textBox3.Text);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            grid.reportX.SetCellAlias(int.Parse(textBox4.Text), int.Parse(textBox5.Text), "");
        }

        private void button3_Click(object sender, EventArgs e)
        {
              int tempInt1;
              int tempInt2;

              grid.reportX.GetCellCoordinate(textBox6.Text, out tempInt1, out tempInt2);
              grid.reportX.SetCellAlias(tempInt1, tempInt2, "");
        }

        private void button4_Click(object sender, EventArgs e)
        {
            listView1.Items.Clear();
            for (int i = 1; i <= grid.reportX.ColCount; i++)
            {
                for (int j = 1; j <= grid.reportX.RowCount; j++)
                {
                    string tempStr = grid.reportX.GetCellAlias(i, j);
                    if (tempStr != "")
                    {
                        ListViewItem tempItem = listView1.Items.Add(i.ToString());
                        tempItem.SubItems.Add(j.ToString());
                        tempItem.SubItems.Add(tempStr);
                    }
                }
            }
        }

        private void reportX1_InputChange(object sender, ReportX.InputChangeEventArgs e)
        {
            textBox1.Text = e.aCol.ToString();
            textBox2.Text = e.aRow.ToString();
            textBox3.Text = reportX1.GetCellAlias(e.aCol, e.aRow);
            textBox4.Text = e.aRow.ToString();
            textBox5.Text = e.aRow.ToString();
            textBox6.Text = reportX1.GetCellAlias(e.aCol, e.aRow);
        }

        private void Alias_Load(object sender, EventArgs e)
        {
            reportX1.OpenString(grid.reportX.SaveString(false), false);
            reportX1.PoleReadOnly = true;
            reportX1.CellReadOnly = true;
        }
    }
}