using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Designer
{
    public partial class Cell : Form
    {
        public Grid grid;

        public Cell()
        {
            InitializeComponent();

            System.Drawing.Text.InstalledFontCollection fonts =
                new System.Drawing.Text.InstalledFontCollection();
            foreach (FontFamily family in fonts.Families)
            {
                listBox1.Items.Add(family.Name);
            }
            foreach (InputLanguage inputLaguage in InputLanguage.InstalledInputLanguages)
            {
                comboBox3.Items.Add(inputLaguage.LayoutName);
            }
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int tempInt1;
            int tempInt2;
            string tempStr;
            ReportX.TFormatType tempFormat;

            switch (tabControl1.SelectedIndex)
            {
                case 0:
                    grid.reportX.GetCellFormat(grid.inputx, grid.inputy, out tempFormat, out tempStr);
                    switch (tempFormat)
                    {
                        case ReportX.TFormatType.TextFormat:
                            listView1.Items[0].Selected = true;
                            break;
                        case ReportX.TFormatType.NumberFormat:
                            listView1.Items[1].Selected = true;
                            break;
                        case ReportX.TFormatType.NumberFormat2:
                            listView1.Items[2].Selected = true;
                            break;
                        case ReportX.TFormatType.DateFormat:
                            listView1.Items[3].Selected = true;
                            break;
                        case ReportX.TFormatType.TimeFormat:
                            listView1.Items[4].Selected = true;
                            break;
                    }
                    break;
                case 1:
                    switch (grid.reportX.GetCellType(grid.inputx, grid.inputy))
                    {
                        case ReportX.TCellType.TextCell:
                            listView2.Items[0].Selected = true;
                            break;
                        case ReportX.TCellType.DropCell:
                            listView2.Items[1].Selected = true;
                            break;
                        case ReportX.TCellType.ButtonCell:
                            listView2.Items[2].Selected = true;
                            break;
                        case ReportX.TCellType.CheckCell:
                            listView2.Items[2].Selected = true;
                            break;
                        case ReportX.TCellType.RadioCell:
                            listView2.Items[1].Selected = true;
                            break;
                        case ReportX.TCellType.DateCell:
                            listView2.Items[5].Selected = true;
                            break;
                        case ReportX.TCellType.TimeCell:
                            listView2.Items[6].Selected = true;
                            break;
                    }
                    break;
                case 2:
                    switch (grid.reportX.GetCellHAlignment(grid.inputx, grid.inputy))
                    {
                        case ReportX.THAlignment.LeftJustify:
                            comboBox1.SelectedIndex = 0;
                            break;
                        case ReportX.THAlignment.HCenter:
                            comboBox1.SelectedIndex = 1;
                            break;
                        case ReportX.THAlignment.RightJustify:
                            comboBox1.SelectedIndex = 2;
                            break;
                    }
                    switch (grid.reportX.GetCellVAlignment(grid.inputx, grid.inputy))
                    {
                        case ReportX.TVAlignment.TopJustify:
                            comboBox2.SelectedIndex = 0;
                            break;
                        case ReportX.TVAlignment.VCenter:
                            comboBox2.SelectedIndex = 1;
                            break;
                        case ReportX.TVAlignment.BottomJustify:
                            comboBox2.SelectedIndex = 2;
                            break;
                    }
                    break;
                case 3:
                    listBox1.SelectedIndex = listBox1.Items.IndexOf(
                        grid.reportX.GetCellFontName(grid.inputx, grid.inputy));
                    listBox2.SelectedIndex = -1;
                    if (grid.reportX.GetCellFontStyle(grid.inputx, grid.inputy, 0) == true)
                        listBox2.SetSelected(0, true);
                    if (grid.reportX.GetCellFontStyle(grid.inputx, grid.inputy, 1) == true)
                        listBox2.SetSelected(1, true);
                    if (grid.reportX.GetCellFontStyle(grid.inputx, grid.inputy, 2) == true)
                        listBox2.SetSelected(2, true);
                    if (grid.reportX.GetCellFontStyle(grid.inputx, grid.inputy, 3) == true)
                        listBox2.SetSelected(3, true);
                    listBox3.SelectedIndex = listBox3.Items.IndexOf(
                        grid.reportX.GetCellFontSize(grid.inputx, grid.inputy).ToString());
                    checkBox2.Checked = grid.reportX.GetCellMultiline(grid.inputx, grid.inputy);
                    button6.ForeColor = grid.reportX.GetCellFontColor(grid.inputx, grid.inputy);
                    button7.BackColor = grid.reportX.GetCellBackColor(grid.inputx, grid.inputy);
                    break;
                case 4:
                    break;
                case 5:
                    comboBox3.SelectedIndex = comboBox3.Items.IndexOf(
                        grid.reportX.GetCellIme(grid.inputx, grid.inputy)) + 1;
                    switch ( grid.reportX.GetCellControl(grid.inputx, grid.inputy) )
                    {
                        case ReportX.TControlType.NoneControl:
                            comboBox4.SelectedIndex = 0;
                            break;
                        case ReportX.TControlType.LetterControl:
                            comboBox4.SelectedIndex = 1;
                            break;
                        case ReportX.TControlType.NaturalControl:
                            comboBox4.SelectedIndex = 2;
                            break;
                        case ReportX.TControlType.WholeControl:
                            comboBox4.SelectedIndex = 3;
                            break;
                        case ReportX.TControlType.RealControl:
                            comboBox4.SelectedIndex = 4;
                            break;
                        case ReportX.TControlType.NameControl:
                            comboBox4.SelectedIndex = 5;
                            break;
                        case ReportX.TControlType.NameControl2:
                            comboBox4.SelectedIndex = 6;
                            break;
                    }
                    switch (grid.reportX.GetCellCharCase(grid.inputx, grid.inputy))
                    {
                        case CharacterCasing.Normal:
                            comboBox5.SelectedIndex = 0;
                            break;
                        case CharacterCasing.Upper:
                            comboBox5.SelectedIndex = 1;
                            break;
                        case CharacterCasing.Lower:
                            comboBox5.SelectedIndex = 2;
                            break;
                    }
                    textBox7.Text = grid.reportX.GetCellTextLength(grid.inputx, 
                        grid.inputy).ToString();
                    checkBox3.Checked = grid.reportX.GetCellReadOnly(grid.inputx,
                        grid.inputy);
                    switch ( grid.reportX.EnterTo )
                    {
                        case 0:
                            radioButton13.Checked = true;
                            break;
                        case 1:
                            radioButton14.Checked = true;
                            break;
                        case 2:
                            radioButton15.Checked = true;
                            break;
                        case 3:
                            radioButton16.Checked = true;
                            break;
                    }
                    break;
                case 6:
                    grid.reportX.GetCellNextPos(grid.inputx, grid.inputy,
                        out tempInt1, out tempInt2);
                    textBox8.Text = tempInt1.ToString();
                    textBox9.Text = tempInt2.ToString();
                    checkBox4.Checked = grid.reportX.GetCellPrintHide(grid.inputx, grid.inputy);
                    break;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            List<string> tempStrs;

            switch (tabControl1.SelectedIndex)
            {
                case 0:
                    if (listView1.SelectedItems.Count > 0)
                    {
                        switch (listView1.SelectedItems[0].Index)
                        {
                            case 0:
                                grid.reportX.InvalidatePaint();
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetCellFormat(i, j, ReportX.TFormatType.TextFormat,
                                            textBox1.Text);
                                grid.reportX.ValidatePaint();
                                break;
                            case 1:
                                grid.reportX.InvalidatePaint();
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetCellFormat(i, j, ReportX.TFormatType.NumberFormat,
                                            textBox1.Text);
                                grid.reportX.ValidatePaint();
                                break;
                            case 2:
                                grid.reportX.InvalidatePaint();
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetCellFormat(i, j, ReportX.TFormatType.NumberFormat2,
                                            textBox1.Text);
                                grid.reportX.ValidatePaint();
                                break;
                            case 3:
                                grid.reportX.InvalidatePaint();
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetCellFormat(i, j, ReportX.TFormatType.DateFormat,
                                            textBox1.Text);
                                grid.reportX.ValidatePaint();
                                break;
                            case 4:
                                grid.reportX.InvalidatePaint();
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetCellFormat(i, j, ReportX.TFormatType.TimeFormat,
                                            textBox1.Text);
                                grid.reportX.ValidatePaint();
                                break;
                        }
                    }
                    break;
                case 1:
                    if (listView2.SelectedItems.Count > 0)
                    {
                        switch (listView2.SelectedItems[0].Index)
                        {
                            case 0:
                                grid.reportX.InvalidatePaint();
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetTextCell(i, j);
                                grid.reportX.ValidatePaint();
                                break;
                            case 1:
                                grid.reportX.InvalidatePaint();
                                tempStrs = new List<string>();
                                for (int i = 0; i < textBox3.Lines.Length; i++)
                                    tempStrs.Add(textBox3.Lines[i]);
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetDropCell(i, j, tempStrs);
                                grid.reportX.ValidatePaint();
                                break;
                            case 2:
                                grid.reportX.InvalidatePaint();
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetButtonCell(i, j, textBox2.Text, textBox4.Text);
                                grid.reportX.ValidatePaint();
                                break;
                            case 3:
                                grid.reportX.InvalidatePaint();
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetCheckCell(i, j, textBox2.Text);
                                grid.reportX.ValidatePaint();
                                break;
                            case 4:
                                grid.reportX.InvalidatePaint();
                                tempStrs = new List<string>();
                                for (int i = 0; i < textBox3.Lines.Length; i++)
                                    tempStrs.Add(textBox3.Lines[i]);
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetRadioCell(i, j, tempStrs);
                                grid.reportX.ValidatePaint();
                                break;
                            case 5:
                                grid.reportX.InvalidatePaint();
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetDateCell(i, j);
                                grid.reportX.ValidatePaint();
                                break;
                            case 6:
                                grid.reportX.InvalidatePaint();
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetTimeCell(i, j);
                                grid.reportX.ValidatePaint();
                                break;
                            case 7:
                                grid.reportX.InvalidatePaint();
                                for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                    for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                        grid.reportX.SetLinkCell(i, j, textBox11.Text, textBox12.Text);
                                grid.reportX.ValidatePaint();
                                break;
                        }
                    }
                    break;
                case 2:
                    grid.reportX.InvalidatePaint();
                    switch (comboBox1.SelectedIndex)
                    {
                        case 0:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellHAlignment(i, j, ReportX.THAlignment.LeftJustify);
                            break;
                        case 1:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellHAlignment(i, j, ReportX.THAlignment.HCenter);
                            break;
                        case 2:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellHAlignment(i, j, ReportX.THAlignment.RightJustify);
                            break;
                    }
                    switch (comboBox2.SelectedIndex)
                    {
                        case 0:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellVAlignment(i, j, ReportX.TVAlignment.TopJustify);
                            break;
                        case 1:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellVAlignment(i, j, ReportX.TVAlignment.VCenter);
                            break;
                        case 2:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellVAlignment(i, j, ReportX.TVAlignment.BottomJustify);
                            break;
                    }
                    if (textBox5.Text.Trim() == "")
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.DelCellPicture(i, j);
                    }
                    else
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.AddCellPicture(i, j, textBox5.Text, checkBox1.Checked);
                    }
                    grid.reportX.ValidatePaint();
                    break;
                case 3:
                    grid.reportX.InvalidatePaint();
                    if (listBox1.SelectedIndex > -1)
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.SetCellFontName(i, j, listBox1.Items[
                                    listBox1.SelectedIndex].ToString());
                    }
                    for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                        for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                            grid.reportX.SetCellFontStyle(i, j, 0, listBox2.GetSelected(0));
                    for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                        for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                            grid.reportX.SetCellFontStyle(i, j, 1, listBox2.GetSelected(1));
                    for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                        for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                            grid.reportX.SetCellFontStyle(i, j, 2, listBox2.GetSelected(2));
                    for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                        for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                            grid.reportX.SetCellFontStyle(i, j, 3, listBox2.GetSelected(3));
                    if (listBox3.SelectedIndex > -1)
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.SetCellFontSize(i, j, (int)listBox3.Items[listBox3.SelectedIndex]);
                    }
                    for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                        for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                            grid.reportX.SetCellMultiline(i, j, checkBox2.Checked);
                    for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                        for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                            grid.reportX.SetCellFontColor(i, j, button6.ForeColor);
                    for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                        for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                            grid.reportX.SetCellBackColor(i, j, button7.BackColor);
                    grid.reportX.ValidatePaint();
                    break;
                case 4:
                    grid.reportX.InvalidatePaint();
                    int tempStyle = 0;
                    if (radioButton8.Checked == true)
                        tempStyle = 0;
                    else if (radioButton8.Checked == true)
                        tempStyle = 1;
                    else if (radioButton8.Checked == true)
                        tempStyle = 2;
                    else if (radioButton8.Checked == true)
                        tempStyle = 3;
                    else if (radioButton8.Checked == true)
                        tempStyle = 4;
                    if (radioButton1.Checked == true)
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.SetCellBorder(i, j, 1, 
                                    int.Parse(textBox6.Text.Trim()), tempStyle);
                    }
                    else if (radioButton2.Checked == true)
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.SetCellBorder(i, j, 2,
                                    int.Parse(textBox6.Text.Trim()), tempStyle);
                    }
                    else if (radioButton3.Checked == true)
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.SetCellBorder(i, j, 3,
                                    int.Parse(textBox6.Text.Trim()), tempStyle);
                    }
                    else if (radioButton4.Checked == true)
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.SetCellBorder(i, j, 4,
                                    int.Parse(textBox6.Text.Trim()), tempStyle);
                    }
                    else if (radioButton5.Checked == true)
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                        {
                            grid.reportX.SetCellBorder(i, grid.selectMiny, 2,
                                int.Parse(textBox6.Text.Trim()), tempStyle);
                            grid.reportX.SetCellBorder(i, grid.selectMaxy, 4, 
                                int.Parse(textBox6.Text.Trim()), tempStyle);
                        }
                        for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                        {
                            grid.reportX.SetCellBorder(grid.selectMinx, j, 1, 
                                int.Parse(textBox6.Text.Trim()), tempStyle);
                            grid.reportX.SetCellBorder(grid.selectMaxx, j, 3, 
                                int.Parse(textBox6.Text.Trim()), tempStyle);
                        }
                    }
                    else if (radioButton6.Checked == true)
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                        {
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                            {
                                if (i != grid.selectMinx)
                                    grid.reportX.SetCellBorder(i, j, 1,
                                        int.Parse(textBox6.Text.Trim()), tempStyle);
                                if (j != grid.selectMiny)
                                    grid.reportX.SetCellBorder(i, j, 2, 
                                        int.Parse(textBox6.Text.Trim()), tempStyle);
                                if (i != grid.selectMaxx)
                                    grid.reportX.SetCellBorder(i, j, 3, 
                                        int.Parse(textBox6.Text.Trim()), tempStyle);
                                if (j != grid.selectMaxy)
                                    grid.reportX.SetCellBorder(i, j, 4, 
                                        int.Parse(textBox6.Text.Trim()), tempStyle);
                            }
                        }
                    }
                    else if (radioButton7.Checked == true)
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.SetCellBorder(i, j, 0,
                                    int.Parse(textBox6.Text.Trim()), tempStyle);
                    }
                    grid.reportX.ValidatePaint();
                    break;
                case 5:
                    if (comboBox3.SelectedIndex == 0)
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.SetCellIme(i, j, "");
                    }
                    else if (comboBox3.SelectedIndex > 0)
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.SetCellIme(i, j, comboBox3.Items[comboBox3.SelectedIndex].ToString());
                    }
                    switch (comboBox4.SelectedIndex)
                    {
                        case 0:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellControl(i, j, ReportX.TControlType.NoneControl);
                            break;
                        case 1:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellControl(i, j, ReportX.TControlType.LetterControl);
                            break;
                        case 2:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellControl(i, j, ReportX.TControlType.NaturalControl);
                            break;
                        case 3:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellControl(i, j, ReportX.TControlType.WholeControl);
                            break;
                        case 4:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellControl(i, j, ReportX.TControlType.NameControl);
                            break;
                        case 5:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellControl(i, j, ReportX.TControlType.NameControl2);
                            break;
                        case 6:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellControl(i, j, ReportX.TControlType.RealControl);
                            break;

                    }
                    switch (comboBox5.SelectedIndex)
                    {
                        case 0:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellCharCase(i, j, CharacterCasing.Normal);
                            break;
                        case 1:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellCharCase(i, j, CharacterCasing.Upper);
                            break;
                        case 2:
                            for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                                for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                    grid.reportX.SetCellCharCase(i, j, CharacterCasing.Lower);
                            break;
                    }
                    if (textBox3.Text.Trim() != "")
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.SetCellTextLength(i, j, int.Parse(textBox7.Text.Trim()));
                    }
                    for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                        for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                            grid.reportX.SetCellReadOnly(i, j, checkBox3.Checked);
                    if (radioButton13.Checked)
                        grid.reportX.EnterTo = 0;
                    else if (radioButton14.Checked)
                        grid.reportX.EnterTo = 1;
                    else if (radioButton15.Checked)
                        grid.reportX.EnterTo = 2;
                    else if (radioButton16.Checked)
                        grid.reportX.EnterTo = 3;
                    break;
                case 6:
                    if (textBox8.Text.Trim() != "" && textBox9.Text.Trim() != "")
                    {
                        for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                            for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                                grid.reportX.SetCellNextPos(i, j, int.Parse(textBox8.Text.Trim()),
                                    int.Parse(textBox9.Text.Trim()));
                    }
                    for (int i = grid.selectMinx; i <= grid.selectMaxx; i++)
                        for (int j = grid.selectMiny; j <= grid.selectMaxy; j++)
                            grid.reportX.SetCellPrintHide(i, j, checkBox4.Checked);
                    break;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                pictureBox1.Load(openFileDialog1.FileName);
                textBox5.Text = openFileDialog1.FileName;
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            textBox5.Text = "";
            checkBox1.Checked = false;
        }

        private void Cell_Load(object sender, EventArgs e)
        {
            tabControl1_SelectedIndexChanged(tabControl1, e);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                button6.ForeColor = colorDialog1.Color;
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                button7.BackColor = colorDialog1.Color;
            }
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            ReportX.TFormatType tempFormat;
            string tempStr;

            if (listView1.SelectedIndices.Count > 0)
            {
                grid.reportX.GetCellFormat(grid.inputx, grid.inputy, out tempFormat, out tempStr);
                switch (listView1.SelectedIndices[0])
                {
                    case 0:
                        label1.Visible = false;
                        textBox1.Visible = false;
                        break;
                    case 1:
                        label1.Visible = true;
                        textBox1.Visible = true;
                        break;
                    case 2:
                        label1.Visible = true;
                        textBox1.Visible = true;
                        break;
                    case 3:
                        label1.Visible = true;
                        textBox1.Visible = true;
                        break;
                    case 4:
                        label1.Visible = true;
                        textBox1.Visible = true;
                        break;
                }
                textBox1.Text = tempStr;
            }
        }

        private void listView2_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listView2.SelectedIndices.Count > 0)
            {
                switch (listView2.SelectedIndices[0])
                {
                    case 0:
                        label14.Visible = false;
                        textBox3.Visible = false;
                        label15.Visible = false;
                        textBox2.Visible = false;
                        label16.Visible = false;
                        textBox4.Visible = false;
                        button3.Visible = false;
                        label17.Visible = false;
                        label18.Visible = false;
                        label19.Visible = false; 
                        label20.Visible = false;
                        textBox11.Visible = false;
                        textBox12.Visible = false;
                        break;
                    case 1:
                        label14.Visible = true;
                        textBox3.Visible = true;
                        List<string> tempStrs = grid.reportX.GetCellDropText(grid.inputx, grid.inputy);
                        textBox3.Clear();
                        if (tempStrs != null)
                        {
                            for (int i = 0; i < tempStrs.Count; i++)
                            {
                                if (i == tempStrs.Count - 1)
                                    textBox3.AppendText(tempStrs[i]);
                                else
                                    textBox3.AppendText(tempStrs[i] + "\r\n");
                            }
                        }
                        label15.Visible = false;
                        textBox2.Visible = false;
                        label16.Visible = false;
                        textBox4.Visible = false;
                        button3.Visible = false;
                        label17.Visible = false;
                        label18.Visible = false;
                        label19.Visible = false;
                        label20.Visible = false;
                        textBox11.Visible = false;
                        textBox12.Visible = false;
                        break;
                    case 2:
                        label14.Visible = false;
                        textBox3.Visible = false;
                        label15.Visible = true;
                        textBox2.Visible = true;
                        textBox2.Text = grid.reportX.GetCellButtonText(grid.inputx, grid.inputy);
                        label16.Visible = true;
                        textBox4.Visible = true;
                        textBox4.Text = grid.reportX.GetCellButtonScript(grid.inputx, grid.inputy);
                        button3.Visible = false;
                        label17.Visible = false;
                        label18.Visible = false;
                        label19.Visible = false;
                        label20.Visible = false;
                        textBox11.Visible = false;
                        textBox12.Visible = false;
                        break;
                    case 3:
                        label14.Visible = false;
                        textBox3.Visible = false;
                        label15.Visible = false;
                        textBox2.Visible = true;
                        textBox2.Text = grid.reportX.GetCellButtonText(grid.inputx, grid.inputy);
                        label16.Visible = false;
                        textBox4.Visible = false;
                        textBox4.Text = "";
                        button3.Visible = true;
                        label17.Visible = true;
                        label18.Visible = false;
                        label19.Visible = false;
                        label20.Visible = false;
                        textBox11.Visible = false;
                        textBox12.Visible = false;
                        break;
                    case 4:
                        label14.Visible = false;
                        textBox3.Visible = true;
                        tempStrs = grid.reportX.GetCellDropText(grid.inputx, grid.inputy);
                        textBox3.Clear();
                        if (tempStrs != null)
                        {
                            for (int i = 0; i < tempStrs.Count; i++)
                            {
                                if (i == tempStrs.Count - 1)
                                    textBox3.AppendText(tempStrs[i]);
                                else
                                    textBox3.AppendText(tempStrs[i] + "\r\n");
                            }
                        }
                        label15.Visible = false;
                        textBox2.Visible = false;
                        label16.Visible = false;
                        textBox4.Visible = false;
                        button3.Visible = false;
                        label17.Visible = false;
                        label18.Visible = true;
                        label19.Visible = false;
                        label20.Visible = false;
                        textBox11.Visible = false;
                        textBox12.Visible = false;
                        break;
                    case 5:
                        label14.Visible = false;
                        textBox3.Visible = false;
                        label15.Visible = false;
                        textBox2.Visible = false;
                        label16.Visible = false;
                        textBox4.Visible = false;
                        button3.Visible = false;
                        label17.Visible = false;
                        label18.Visible = false;
                        label19.Visible = false;
                        label20.Visible = false;
                        textBox11.Visible = false;
                        textBox12.Visible = false;
                        break;
                    case 6:
                        label14.Visible = false;
                        textBox3.Visible = false;
                        label15.Visible = false;
                        textBox2.Visible = false;
                        label16.Visible = false;
                        textBox4.Visible = false;
                        button3.Visible = false;
                        label17.Visible = false;
                        label18.Visible = false;
                        label19.Visible = false;
                        label20.Visible = false;
                        textBox11.Visible = false;
                        textBox12.Visible = false;
                        break;
                    case 7:
                        label14.Visible = false;
                        textBox3.Visible = false;
                        label15.Visible = false;
                        textBox2.Visible = false;
                        label16.Visible = false;
                        textBox4.Visible = false;
                        button3.Visible = false;
                        label17.Visible = false;
                        label18.Visible = false;
                        label19.Visible = true;
                        label20.Visible = true;
                        textBox11.Visible = true;
                        textBox11.Text = grid.reportX.GetCellButtonText(grid.inputx, grid.inputy);
                        textBox12.Visible = true;
                        textBox12.Text = grid.reportX.GetCellButtonScript(grid.inputx, grid.inputy);
                        break;
                }
            }
        }
    }
}