using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Designer
{
    public partial class Expre : Form
    {
        public Grid grid;
        public int ExpressMinx;
        public int ExpressMiny;
        public int ExpressMaxx;
        public int ExpressMaxy;
        public string ExpressStr;
        public string ExpressStart;
        public string ExpressEnd;
        public int ExpressCursor;

        public Expre()
        {
            InitializeComponent();
        }

        private void Expre_Load(object sender, EventArgs e)
        {
            reportX1.OpenString(grid.reportX.SaveString(false), false);
            reportX1.PoleReadOnly = true;
            reportX1.CellReadOnly = true;
            textBox1.Text = ExpressStr;
        }

        private void reportX1_SelectChange(object sender, ReportX.SelectChangeEventArgs e)
        {
            if ((e.aCol1 == e.aCol2) && (e.aRow1 == e.aRow2))
            {
                textBox1.Text = ExpressStart + "GetCell(" +
                  e.aCol1.ToString() + ", " + e.aRow1.ToString() + ")" +
                  ExpressEnd;
                textBox1.SelectionStart = ExpressCursor + 11 +
                  e.aCol1.ToString().Length + e.aRow1.ToString().Length;
            }
            else
            {
                textBox1.Text = ExpressStart + "Sum(" +
                  e.aCol1.ToString() + ", " + e.aRow1.ToString() + ", " +
                  e.aCol2.ToString() + ", " + e.aRow2.ToString() + ")" +
                  ExpressEnd;
                textBox1.SelectionStart = ExpressCursor + 11 +
                  e.aCol1.ToString().Length + e.aRow1.ToString().Length +
                  e.aCol2.ToString().Length + e.aRow2.ToString().Length;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ExpressStr = textBox1.Text;

            DialogResult = DialogResult.OK;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void reportX1_CellLDown(object sender, ReportX.CellMouseLEventArgs e)
        {
            ExpressStart = textBox1.Text.Substring(0, textBox1.SelectionStart);
            ExpressEnd = textBox1.Text.Substring(textBox1.SelectionStart + textBox1.SelectedText.Length,
              textBox1.Text.Length - textBox1.SelectionStart - textBox1.SelectedText.Length);
            ExpressCursor = textBox1.SelectionStart;
        }

        private void reportX1_CellLUp(object sender, ReportX.CellMouseLEventArgs e)
        {
            textBox1.Focus();
        }
    }
}