using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Designer
{
    public partial class Grid : Form
    {
        public int selectMinx;
        public int selectMiny;
        public int selectMaxx;
        public int selectMaxy;
        public int inputx;
        public int inputy;
        public string fileName;

        public Grid()
        {
            InitializeComponent();
        }

        public ReportX.ReportX reportX
        {
            get
            {
                return reportX1;
            }
        }

        private void reportX1_SelectChange(object sender, ReportX.SelectChangeEventArgs e)
        {
            selectMinx = e.aCol1;
            selectMiny = e.aRow1;
            selectMaxx = e.aCol2;
            selectMaxy = e.aRow2;

            ((Main)this.MdiParent).SetMainSelectStatus("(" + e.aCol1.ToString() + "," + e.aRow1.ToString() +
                "):(" + e.aCol2.ToString() + "," + e.aRow2.ToString() + ")"); 
        }

        private void reportX1_InputChange(object sender, ReportX.InputChangeEventArgs e)
        {
            inputx = e.aCol;
            inputy = e.aRow;

            if (e.aCol > 0 && e.aRow > 0)
                ((Main)this.MdiParent).SetMainInputStatus("(" + e.aCol.ToString() + "," + e.aRow.ToString() + ")",
                    reportX1.GetCellFontStyle(e.aCol, e.aRow, 0), reportX1.GetCellFontStyle(e.aCol, e.aRow, 1),
                    reportX1.GetCellFontStyle(e.aCol, e.aRow, 2), reportX1.GetCellFontStyle(e.aCol, e.aRow, 3),
                    reportX1.GetCellMultiline(e.aCol, e.aRow), reportX1.GetCellReadOnly(e.aCol, e.aRow),
                    (reportX1.GetCellHAlignment(e.aCol, e.aRow) == ReportX.THAlignment.LeftJustify),
                    (reportX1.GetCellHAlignment(e.aCol, e.aRow) == ReportX.THAlignment.HCenter),
                    (reportX1.GetCellHAlignment(e.aCol, e.aRow) == ReportX.THAlignment.RightJustify),
                    (reportX1.GetCellVAlignment(e.aCol, e.aRow) == ReportX.TVAlignment.TopJustify),
                    (reportX1.GetCellVAlignment(e.aCol, e.aRow) == ReportX.TVAlignment.VCenter),
                    (reportX1.GetCellVAlignment(e.aCol, e.aRow) == ReportX.TVAlignment.BottomJustify),
                    reportX1.GetCellFontName(e.aCol, e.aRow), reportX1.GetCellFontSize(e.aCol, e.aRow));
            else
                ((Main)this.MdiParent).SetMainInputStatus("(" + e.aCol.ToString() + "," + e.aRow.ToString() + ")",
                    false, false, false, false, false, false, false, false, false, false, false, false, "", 12);
        }

        private void reportX1_CellRDown(object sender, ReportX.CellMouseREventArgs e)
        {
            contextMenuStrip1.Show(e.aScreenX, e.aScreenY);
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.CutCell(selectMinx, selectMiny, selectMaxx, selectMaxy);
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.CopyCell(selectMinx, selectMiny, selectMaxx, selectMaxy);
        }

        private void ճToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Paste(inputx, inputy, true);
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.ClearCell(selectMinx, selectMiny, selectMaxx, selectMaxy);
        }

        private void ϲToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.MergeCell(selectMinx, selectMiny, selectMaxx, selectMaxy);
        }

        private void ָToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.SplitCell(selectMinx, selectMiny, selectMaxx, selectMaxy);
        }

        private void ظToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 0, 0);
        }

        private void ظToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 1, 0);
        }

        private void ظToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 2, 0);
        }

        private void ظToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 3, 0);
        }

        private void ȲToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 0, 1);
        }

        private void ϵȲToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 1, 1);
        }

        private void ҵȲToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 2, 1);
        }

        private void µȲToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 3, 1);
        }

        private void ȱToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 0, 2);
        }

        private void ϵȱToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 1, 2);
        }

        private void ҵȱToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 2, 2);
        }

        private void µȱToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 3, 2);
        }

        private void ʽToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 0, 3);
        }

        private void ϹʽToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 1, 3);
        }

        private void ҹʽToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 2, 3);
        }

        private void ¹ʽToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.Fill(selectMinx, selectMiny, selectMaxx, selectMaxy, 3, 3);
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.InsertCol(inputx, 1);
        }

        private void ɾToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.DeleteCol(selectMinx, selectMaxx - selectMinx + 1);
        }

        private void ׷ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.AppendCol(1);
        }

        private void пToolStripMenuItem_Click(object sender, EventArgs e)
        {
            for (int i = selectMinx; i <= selectMaxx; i++)
                reportX1.SetColWidth(i, reportX1.GetColBestWidth(i));
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.InsertRow(inputy, 1);
        }

        private void ɾToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.DeleteRow(selectMiny, selectMaxy - selectMiny + 1);
        }

        private void ׷ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reportX1.AppendRow(1);
        }

        private void иToolStripMenuItem_Click(object sender, EventArgs e)
        {
            for (int i = selectMiny; i <= selectMaxy; i++)
                reportX1.SetRowHeight(i, reportX1.GetRowBestHeight(i));
        }

        private void reportX1_PoleRDown(object sender, ReportX.PoleMouseREventArgs e)
        {
            if (e.aOrientation == 0)
            {
                contextMenuStrip2.Show(e.aScreenX, e.aScreenY);
            }
            else
            {
                contextMenuStrip3.Show(e.aScreenX, e.aScreenY);
            }
        }

        private void Grid_Activated(object sender, EventArgs e)
        {
            GridActivated();
        }

        public void GridActivated()
        {
            if (((Main)this.MdiParent) != null)
            {
                ((Main)this.MdiParent).SetMainToolBar(reportX.SeparatorLine, reportX.GridLine);
                ((Main)this.MdiParent).SetMainSelectStatus("(" + selectMinx.ToString() + "," + selectMiny.ToString() +
                    "):(" + selectMaxx.ToString() + "," + selectMaxy.ToString() + ")");
                if (inputx > 0 && inputy > 0)
                    ((Main)this.MdiParent).SetMainInputStatus("(" + inputx.ToString() + "," + inputy.ToString() + ")",
                        reportX1.GetCellFontStyle(inputx, inputy, 0), reportX1.GetCellFontStyle(inputx, inputy, 1),
                        reportX1.GetCellFontStyle(inputx, inputy, 2), reportX1.GetCellFontStyle(inputx, inputy, 3),
                        reportX1.GetCellMultiline(inputx, inputy), reportX1.GetCellReadOnly(inputx, inputy),
                        (reportX1.GetCellHAlignment(inputx, inputy) == ReportX.THAlignment.LeftJustify),
                        (reportX1.GetCellHAlignment(inputx, inputy) == ReportX.THAlignment.HCenter),
                        (reportX1.GetCellHAlignment(inputx, inputy) == ReportX.THAlignment.RightJustify),
                        (reportX1.GetCellVAlignment(inputx, inputy) == ReportX.TVAlignment.TopJustify),
                        (reportX1.GetCellVAlignment(inputx, inputy) == ReportX.TVAlignment.VCenter),
                        (reportX1.GetCellVAlignment(inputx, inputy) == ReportX.TVAlignment.BottomJustify),
                        reportX1.GetCellFontName(inputx, inputy), reportX1.GetCellFontSize(inputx, inputy));
                else
                    ((Main)this.MdiParent).SetMainInputStatus("(" + inputx.ToString() + "," + inputy.ToString() + ")",
                        false, false, false, false, false, false, false, false, false, false, false, false, "", 12);
            }
        }
    }
}